unit FindVersion1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ShellCtrls, ComCtrls;

type

		{ TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
  Label1: TLabel;
  ListBox1: TListBox;
  ShellListView1: TShellListView;
  ShellTreeView1: TShellTreeView;
  procedure Button1Click(Sender: TObject);
  procedure Button2Click(Sender: TObject);
  procedure ShellListView1DblClick(Sender: TObject);
  procedure LoadFile(fname: string);
  procedure searchLazFPC;
  private
  buf : array of char;
  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.LoadFile(fname: string);
var fsize : Int64;
    f : file of byte;
begin
assignFile(f,fname);
reset(f,1);
fsize := FileSize(f);
//showMessage (fname+LineEnding+IntToStr(fsize));
Label1.Caption := 'Loading '+IntToStr(fsize)+' bytes';
Application.ProcessMessages;
setLength(buf,fsize);
BlockRead(f,buf[0],fsize);
Label1.Caption := IntToStr(fsize)+' bytes loaded';
closeFile(f);
end;

procedure TForm1.searchLazFPC;
const search : array[0..1] of string = ('Free Pascal','Lazarus LCL');
var s,res: string;
    len,i,k,loop,per: integer;
    found : boolean;

    function ReadToEOLN : String;
    var m : integer;
    begin
    m := i;  result := '';
    while not (buf[m] in [#10,#13]) do
       begin
       result := result+buf[m];
       inc(m);
       end;
    end;

begin
   for loop := 0 to 1 do
      begin
      s := search[loop];
      len := length(s);
      res := '';
      Label1.Caption := 'Scanning '+s;
      application.ProcessMessages;
      for i := 0 to high(buf) - len do
        begin
        k := 0; found := true;
        while found and (k < len)  do
          begin
          found := buf[i+k]=s[k+1];
          if found then inc(k);
          end; //k
          if found then
             begin
             res := readtoEOLN ;
             Listbox1.Items.add(res);
             end;
        if i mod 10000 = 0 then
          begin
          per := round(i*100/high(buf));
          Label1.caption := IntToStr(per)+'% '+s;
          Application.ProcessMessages;
          end;
        end; // i
     end; //loop
end;

procedure TForm1.ShellListView1DblClick(Sender: TObject);
var
  Item: TListItem;
  fname: string;
begin
  Item := TShellListView(Sender).Selected;
  if Assigned(Item) then
  begin
    fname := IncludeTrailingPathDelimiter(TShellListView(Sender).Root) + Item.Caption;
    ListBox1.Clear;
    ListBox1.Items.add(fname);
    application.ProcessMessages;
    LoadFile(fname);
    searchLazFPC;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var fname : string;
begin
if listbox1.items.Count > 0 then
  begin
  fname := ListBox1.Items[0]+'.info.txt';
  ListBox1.Items.SaveToFile(fname);
  showMessage('Saved:'+LineEnding+fname);
  end else showMessage ('Nothing to save');

end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  close;
end;




end.

